<template>
  <t-dropdown-button
    :variant="variant || dropdown.variant"
    :variants="tDropdownButtonStyle.variants"
    :classes="tDropdownButtonStyle.classes"
    :fixed-classes="tDropdownButtonStyle.fixedClasses"
    type="button"
    @blur="blurHandler"
    @click="clickHandler"
  >
    <!-- @slot Default slot -->
    <slot />
  </t-dropdown-button>
</template>

<script>
// Mixins
import { Variantable, VariantableOptions } from '@/mixins/variantable'
// Component style
import Style from './style'

/**
 * VDropdownButton component
 */
export default {
  name: 'VDropdownButton',
  mixins: [
    Variantable
  ],
  props: {
    /**
     * Parent dropdown default slot props
     * @type {Object}
     */
    dropdown: {
      type: Object,
      required: true
    },
    /**
     * Function called on blur
     * @type {Function}
     */
    onBlur: {
      type: Function,
      default () {
        return async function (evt) {}
      }
    },
    /**
     * Function called on click
     * @type {Function}
     */
    onClick: {
      type: Function,
      default () {
        return async function (evt) {}
      }
    }
  },
  computed: {
    /**
     * ⚠ We have to return css classes as array because vue-tailwind TDropdownButton component
     * does not accept classes as object
     */
    tDropdownButtonStyle () {
      return new VariantableOptions(this.overriddenStyle, { cssClassesFormat: 'array' })
    }
  },
  methods: {
    /**
     * Blur handler
     * @param {Object} evt - The event
     */
    async blurHandler (evt) {
      await this.onBlur(evt)
      this.dropdown.blurHandler(evt)
    },
    /**
     * Click handler
     * @param {Object} evt - The event
     */
    async clickHandler (evt) {
      // await this.onClick(evt)
      this.$emit('click', evt)
      this.dropdown.hide()
    }
  },
  // Variantable options
  style: Style
}
</script>

<style lang="scss">
// ...
</style>

<docs lang="md">
See
</docs>
